## zynaddsubfx 2.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
project(zynaddsubfx)
set(VERSION "2.5.1")


#Include RTOSC
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/rtosc/CMakeLists.txt")
    message(STATUS "RTOSC NOT FOUND")
    message(STATUS "Attempting to checkout submodule")
    find_package(Git REQUIRED)
    execute_process(COMMAND git submodule update --init)
    if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/rtosc/CMakeLists.txt")
        message(FATAL_ERROR "FAILED TO CHECKOUT RTOSC\n"
        "please check file permissions and your network")
    endif()
else()
    message(STATUS "Found Rtosc Submodule...")
endif()

set(RTOSC_NO_INSTALL TRUE)
include("rtosc/cmake/ColorMessage.cmake")
add_subdirectory(rtosc)
include_directories(rtosc/include)

enable_testing()
include(CTestConfig.cmake)
#Currently the only directory that uses cmake
add_subdirectory(src)

install(FILES AUTHORS.txt COPYING FAQ.txt HISTORY.txt README.adoc
	DESTINATION share/doc/zynaddsubfx
	)
install(FILES zynaddsubfx-jack.desktop zynaddsubfx-alsa.desktop
    DESTINATION share/applications)
install(FILES zynaddsubfx.svg
    DESTINATION share/pixmaps)
install(DIRECTORY instruments/banks
    DESTINATION share/zynaddsubfx)
install(DIRECTORY instruments/examples
    DESTINATION share/zynaddsubfx)

=== rtosc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(RTOSC)

set(VERSION_MAJOR 0)
set(VERSION_MINOR 1)
set(VERSION_PATCH 0)

include("cmake/ColorMessage.cmake")
SET(BUILD_RTOSC_EXAMPLES FALSE CACHE BOOL
    "Build RTOSC Example Programs")

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    include(GNUInstallDirs)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
if(NOT WIN32)
    set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -O2 -fPIC -std=c99   -Wall -Wextra")
    set(CPP_FLAGS       "-O2 -fPIC -std=c++11 -Wall -Wextra -Wno-unused-parameter")
endif()

if(CMAKE_COMPILER_IS_GNUCC)
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
        OUTPUT_VARIABLE GCC_VERSION)
    if (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL
            4.7)
        message(STATUS "Found GCC Version >= 4.7")
    else()
        message(WARNING "GCC Version '${GCC_VERSION}' Is Quite Old, Please Consider Upgrading")
        set(CPP_FLAGS "-O2 -fPIC -std=c++0x -Wall -Wextra -Wno-unused-parameter")
    endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPP_FLAGS}")

add_library(rtosc STATIC src/rtosc.c src/dispatch.c)
add_library(rtosc-cpp STATIC src/cpp/ports.cpp src/cpp/miditable.cpp
    src/cpp/midimapper.cpp
    src/cpp/thread-link.cpp
    src/cpp/undo-history.cpp
    src/cpp/subtree-serialize.cpp)
target_link_libraries(rtosc-cpp rtosc)

# Example Code
find_package(FLTK)
find_package(PkgConfig)
if(PKG_CONFIG_FOUND)
    pkg_check_modules(NTK ntk)
    pkg_check_modules(JACK jack)
    pkg_check_modules(LIBLO liblo>=0.28)
endif()

if(FLTK_FOUND)
    execute_process(COMMAND fltk-config --api-version
        OUTPUT_VARIABLE FLTK_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(FLTK_FOUND)

if(NTK_FOUND)
    #Default to NTK, as everything looks better there
    set(GUI_FOUND TRUE)
    set(GUI_LIBRARIES ${NTK_LDFLAGS})
    include_directories(${NTK_INCLUDE_DIRS})
elseif(FLTK_FOUND AND (FLTK_VERSION STREQUAL "1.3"))
    set(GUI_FOUND TRUE)
    set(GUI_LIBRARIES ${FLTK_LIBRARIES})
else()
    set(GUI_FOUND FALSE)
endif()


if(JACK_FOUND AND GUI_FOUND AND BUILD_RTOSC_EXAMPLES)
    add_executable(simple-example example/simple/ui.cpp example/simple/synth.cpp)
    target_link_libraries(simple-example m rtosc ${GUI_LIBRARIES}
        ${JACK_LDFLAGS})

    add_executable(complex-example example/complex/audio.cpp
        example/complex/synth.cpp example/complex/window.cpp
        example/complex/Fl_Osc_Dial.cpp example/complex/Fl_Osc_Slider.cpp
        example/complex/Fl_Osc_Button.cpp)
    target_link_libraries(complex-example m rtosc rtosc-cpp ${GUI_LIBRARIES}
        ${JACK_LDFLAGS})
    #TODO add complex example (ie klatter (an unplublished project for those reading))
endif()

if(BUILD_RTOSC_EXAMPLES)
    add_executable(modular-example
        example/modular/Echo.cpp
        example/modular/EffectMgr.cpp
        example/modular/LFO.cpp
        example/modular/main.cpp
        example/modular/Oscil.cpp
        example/modular/Synth.cpp
        example/modular/util.cpp
        )
    target_link_libraries(modular-example m rtosc rtosc-cpp)
endif(BUILD_RTOSC_EXAMPLES)


# Testing code
enable_testing()
macro(maketest fname)
    add_executable(${fname} test/${fname}.c)
    add_test(${fname} ${fname})
    target_link_libraries(${fname} rtosc)
endmacro(maketest)

macro(maketestcpp fname)
    add_executable(${fname} test/${fname}.cpp)
    add_test(${fname} ${fname})
    target_link_libraries(${fname} rtosc-cpp rtosc)
endmacro(maketestcpp)

maketest(osc-spec)
maketest(simple-messages)
maketest(null-messages)
maketest(bundles)
maketest(patterns)
maketest(nested-bundles)
maketest(fat-message)
maketest(empty-strings)
maketest(message-alignment)
if(LIBLO_FOUND)
    include_directories(${LIBLO_INCLUDE_DIRS})
    maketest(liblo)
    target_link_libraries(liblo ${LIBLO_LDFLAGS})
endif()

if(JACK_FOUND)
    include_directories(${JACK_INCLUDE_DIRS})
endif()

maketestcpp(metadata)
maketestcpp(headerlib)
maketestcpp(test-walker)
maketestcpp(performance)

maketestcpp(undo-test)
maketestcpp(serializer)
maketestcpp(sugar)
maketestcpp(typed-template-test)

# Documentation
find_package(Doxygen)
SET(Documentation FALSE CACHE BOOL "Enable building documentation")

if(DOXYGEN_FOUND AND Documentation)
    set(CMAKE_DOXYGEN_INPUT_LIST ${CMAKE_SOURCE_DIR}/include/)
    SET(DOXYGEN_OUTPUT_DIR html)
    CONFIGURE_FILE(Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    SET(HTML_TARGET “html” )
    ADD_CUSTOM_TARGET(${HTML_TARGET} ALL
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
endif()


#Installation
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT DEFINED RTOSC_NO_INSTALL)
    if(PKG_CONFIG_FOUND)
        configure_file(librtosc.pc.cmake
            ${CMAKE_BINARY_DIR}/librtosc.pc @ONLY)
        install(FILES ${CMAKE_BINARY_DIR}/librtosc.pc
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
    endif()
    install(FILES include/rtosc/rtosc.h
        include/rtosc/thread-link.h
        include/rtosc/ports.h
        include/rtosc/miditable.h
        include/rtosc/port-sugar.h
        include/rtosc/undo-history.h
        include/rtosc/subtree-serialize.h
        include/rtosc/typed-message.h
        DESTINATION include/rtosc)
    install(TARGETS rtosc rtosc-cpp
        DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()


#Describe overall configuration
message(STATUS)
message(STATUS "${ColorBold}Rtosc Build Configuration")
message(STATUS             "=========================${ColorReset}")
message(STATUS)

if(PKG_CONFIG_FOUND)
    message(STATUS "PkgConfig enabled  -- ${Green}package found${ColorReset}")
else()
    message(STATUS "PkgConfig disabled -- ${Yellow}package NOT found${ColorReset}")
endif()
if(LIBLO_FOUND)
    message(STATUS "Liblo enabled      -- ${Green}package found${ColorReset}")
else()
    message(STATUS "Liblo disabled     -- ${Yellow}package NOT found${ColorReset}")
endif()
if(JACK_FOUND)
    message(STATUS "JACK enabled       -- ${Green}package found${ColorReset}")
else()
    message(STATUS "JACK disabled      -- ${Yellow}package NOT found${ColorReset}")
endif()
if(NTK_FOUND)
    message(STATUS "NTK enabled        -- ${Green}package found${ColorReset}")
else()
    message(STATUS "NTK disabled       -- ${Yellow}package NOT found${ColorReset}")
endif()

if(FLTK_FOUND)
    if(FLTK_VERSION STREQUAL "1.3")
        message(STATUS "FLTK enabled       -- ${Green}package found${ColorReset}")
    else()
        message(STATUS "FLTK disabled      -- ${Yellow}package found in unsupported version (expected 1.3)${ColorReset}")
    endif()
else()
    message(STATUS "FLTK disabled      -- ${Yellow}package NOT found${ColorReset}")
endif()

=== src/CMakeLists.txt ===
#checking include/library paths
message(STATUS "Checking Include Path" $ENV{CMAKE_INCLUDE_PATH} ${CMAKE_INCLUDE_PATH})
message(STATUS "Checking Library Path" $ENV{CMAKE_LIBRARY_PATH} ${CMAKE_LIBRARY_PATH})

#Dependency check
include(CheckFunctionExists)
find_package(PkgConfig REQUIRED)
find_package(zlib REQUIRED)
find_package(X11)
pkg_check_modules(FFTW REQUIRED fftw3)
pkg_check_modules(MXML REQUIRED mxml)
find_package(Threads   REQUIRED)
find_package(OSS)
find_package(Alsa)
pkg_check_modules(JACK jack)
pkg_check_modules(PORTAUDIO portaudio-2.0>=19)
set(FLTK_SKIP_OPENGL true)
pkg_check_modules(NTK ntk)
pkg_check_modules(NTK_IMAGES ntk_images)
find_package(FLTK)
find_package(OpenGL) #for FLTK
find_package(CxxTest)
if(CXXTEST_FOUND)
    set(CXXTEST_USE_PYTHON TRUE)
endif()
# lash
pkg_search_module(LASH lash-1.0)
mark_as_advanced(LASH_LIBRARIES)
pkg_search_module(DSSI dssi>=0.9.0)
mark_as_advanced(DSSI_LIBRARIES)
pkg_search_module(LIBLO liblo>=0.26 REQUIRED)
mark_as_advanced(LIBLO_LIBRARIES)

CHECK_FUNCTION_EXISTS(sched_setscheduler HAVE_SCHEDULER)

execute_process(COMMAND echo fistpl 0
                COMMAND as -
                ERROR_VARIABLE AVOID_ASM)

######### Settings ###########
# NOTE: These cache variables should normally not be changed in this
# file, but either in in CMakeCache.txt before compile, or by passing
# parameters directly into cmake using the -D flag.
if(NTK_FOUND)
  SET (GuiModule ntk CACHE STRING "GUI module, either fltk, ntk or off")
elseif(FLTK_FOUND)
  SET (GuiModule fltk CACHE STRING "GUI module, either fltk, ntk or off")
else()
  SET (GuiModule off CACHE STRING "GUI module, either fltk, ntk or off")
endif()
SET (CompileTests ${CXXTEST_FOUND} CACHE BOOL "whether tests should be compiled in or not")
SET (AlsaEnable ${ALSA_FOUND} CACHE BOOL
    "Enable support for Advanced Linux Sound Architecture")
SET (JackEnable ${JACK_FOUND} CACHE BOOL
    "Enable support for JACK Audio Connection toolKit")
SET (OssEnable ${OSS_FOUND} CACHE BOOL
    "Enable support for Open Sound System")
SET (PaEnable ${PORTAUDIO_FOUND} CACHE BOOL
    "Enable support for Port Audio System")
SET (LashEnable ${LASH_FOUND} CACHE BOOL
    "Enable LASH Audio Session Handler")
SET (DssiEnable ${DSSI_FOUND} CACHE BOOL
    "Enable DSSI Plugin compilation")
SET (LibloEnable ${LIBLO_FOUND} CACHE BOOL
    "Enable Liblo")

# Now, handle the incoming settings and set define flags/variables based
# on this

# Add version information
add_definitions(-DVERSION="${VERSION}")

if(NOT "Darwin" STREQUAL ${CMAKE_SYSTEM_NAME})
    # Add scheduler function existance info (OSX compatiability)
    add_definitions(-DHAVE_SCHEDULER=${HAVE_SCHEDULER})
endif()


# Give a good guess on the best Input/Output default backends
if (JackEnable)
    SET (DefaultOutput jack CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    # Override with perhaps more helpful midi backends
    if (AlsaEnable)
        SET (DefaultInput alsa CACHE STRING
            "Default Input module: [null, alsa, oss, jack]")
    elseif (OssEnable)
        SET (DefaultInput oss CACHE STRING
            "Default Input module: [null, alsa, oss, jack]")
    else ()
        SET (DefaultInput jack CACHE STRING
            "Default Input module: [null, alsa, oss, jack]")
    endif ()
elseif (AlsaEnable)
    SET (DefaultOutput alsa CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    SET (DefaultInput alsa CACHE STRING
        "Default Input module: [null, alsa, oss, jack]")
elseif (OssEnable)
    SET (DefaultOutput oss CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    SET (DefaultInput oss CACHE STRING
        "Default Input module: [null, alsa, oss, jack]")
else()
    SET (DefaultOutput null CACHE STRING
        "Default Output module: [null, alsa, oss, jack, portaudio]")
    SET (DefaultInput null CACHE STRING
        "Default Input module: [null, alsa, oss, jack]")
endif()



if (GuiModule STREQUAL qt AND QT_FOUND)
	set (QtGui TRUE)
elseif(GuiModule STREQUAL ntk AND NTK_FOUND)
	set (NtkGui TRUE)
elseif(GuiModule STREQUAL fltk AND FLTK_FOUND)
	set (FltkGui TRUE)
elseif(GuiModule STREQUAL off)
        add_definitions(-DDISABLE_GUI)
else  ()
        set (GuiModule off CACHE STRING "GUI module, either fltk, qt or off")
        add_definitions(-DDISABLE_GUI)
	message(STATUS "GUI module defaulting to off")
endif()


#Build Flags
option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
option (BuildForDebug "Include gdb debugging support" OFF)

set(CMAKE_BUILD_TYPE "Release")

set (BuildOptions_x86_64AMD
    "-std=c++11 -O3 -march=athlon64 -m64 -Wall -Wno-unused-parameter -ffast-math -fno-finite-math-only -fomit-frame-pointer"
  CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_X86_64Core2
    "-std=c++11 -O3 -march=core2 -m64 -Wall -Wno-unused-parameter -ffast-math -fno-finite-math-only -fomit-frame-pointer"
  CACHE STRING "X86_64 compiler options"
)

set (BuildOptionsBasic
    "-std=c++11 -Wno-unused-parameter -O3 -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
    CACHE STRING "basic X86 complier options"
)

set (BuildOptionsDebug
    "-std=c++11 -O0 -g3 -ggdb -Wall -Wno-unused-parameter -Wpointer-arith" CACHE STRING "Debug build flags")

########### Settings dependant code ###########
# From here on, the setting variables have  been prepared so concentrate
# on the actual compiling.

# To avoid a conflict if PortAudio v1 is installed, the linker directory
# of portaudio must be specified first, so that xxx/lib/portaudio2 is
# searched before xxx/lib where PortAudio v1 gets installed.
if(PaEnable)
	include_directories(${PORTAUDIO_INCLUDE_DIRS})
	add_definitions(-DPORTAUDIO=1)
	list(APPEND AUDIO_LIBRARIES ${PORTAUDIO_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${PORTAUDIO_LIBRARY_DIRS})
endif()

if(AlsaEnable)
	list(APPEND AUDIO_LIBRARIES ${ASOUND_LIBRARY})
	list(APPEND AUDIO_LIBRARY_DIRS ${ASOUND_LIBRARY_DIRS})
	add_definitions(-DALSA=1)
endif(AlsaEnable)

if(JackEnable)
	list(APPEND AUDIO_LIBRARIES ${JACK_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${JACK_LIBRARY_DIRS})
	add_definitions(-DJACK=1)
endif(JackEnable)

if(OssEnable)
	add_definitions(-DOSS=1)
endif(OssEnable)

if (CompileTests)
	ENABLE_TESTING()
endif()

if(LashEnable)
	include_directories(${LASH_INCLUDE_DIRS})
	add_definitions(-DLASH=1)
	list(APPEND AUDIO_LIBRARIES ${LASH_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${LASH_LIBRARY_DIRS})
	message(STATUS "Compiling with lash")
endif()
if(LibloEnable)
	include_directories(${LIBLO_INCLUDE_DIRS})
	add_definitions(-DUSE_NSM=1)
    list(APPEND AUDIO_LIBRARIES ${LIBLO_LIBRARIES})
	list(APPEND AUDIO_LIBRARY_DIRS ${LIBLO_LIBRARY_DIRS})
	message(STATUS "Compiling with liblo")
endif()

# other include directories
include_directories(${ZLIB_INCLUDE_DIRS} ${MXML_INCLUDE_DIRS})

add_definitions(
	 -Wall
	 -Wextra
	 )
if(NOT AVOID_ASM)
	message(STATUS "Compiling with x86 opcode support")
    add_definitions(-DASM_F2I_YES)
endif()

if (BuildForDebug)
	set (CMAKE_BUILD_TYPE "Debug")
	set (CMAKE_CXX_FLAGS_DEBUG ${BuildOptionsDebug})
	message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_DEBUG}")
else (BuildForDebug)
	set (CMAKE_BUILD_TYPE "Release")
	if (BuildForAMD_X86_64)
		set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_x86_64AMD})
	else (BuildForAMD_X86_64)
		if (BuildForCore2_X86_64)
			set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86_64Core2})
		else (BuildForCore2_X86_64)
			set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
		endif (BuildForCore2_X86_64)
	endif (BuildForAMD_X86_64)
	message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_RELEASE}")
endif (BuildForDebug)

add_definitions(-fPIC)

if(FLTK_FOUND)
	mark_as_advanced(FORCE FLTK_BASE_LIBRARY)
	mark_as_advanced(FORCE FLTK_CONFIG_SCRIPT)
	mark_as_advanced(FORCE FLTK_DIR)
	mark_as_advanced(FORCE FLTK_FLUID_EXECUTABLE)
	mark_as_advanced(FORCE FLTK_FORMS_LIBRARY)
	mark_as_advanced(FORCE FLTK_GL_LIBRARY)
	mark_as_advanced(FORCE FLTK_IMAGES_LIBRARY)
	mark_as_advanced(FORCE FLTK_INCLUDE_DIR)
	mark_as_advanced(FORCE FLTK_MATH_LIBRARY)
endif(FLTK_FOUND)

if(NTK_FOUND)
	mark_as_advanced(FORCE NTK_BASE_LIBRARY)
	mark_as_advanced(FORCE NTK_CONFIG_SCRIPT)
	mark_as_advanced(FORCE NTK_DIR)
	mark_as_advanced(FORCE FLTK_FLUID_EXECUTABLE)
	mark_as_advanced(FORCE NTK_FORMS_LIBRARY)
	mark_as_advanced(FORCE NTK_GL_LIBRARY)
	mark_as_advanced(FORCE NTK_IMAGES_LIBRARY)
	mark_as_advanced(FORCE NTK_INCLUDE_DIR)
	mark_as_advanced(FORCE NTK_MATH_LIBRARY)
endif(NTK_FOUND)

if(FltkGui)
	#UGLY WORKAROUND
	find_program (FLTK_CONFIG fltk-config)
	if (FLTK_CONFIG)
		execute_process (COMMAND ${FLTK_CONFIG} --use-images --ldflags OUTPUT_VARIABLE FLTK_LDFLAGS)
		string(STRIP ${FLTK_LDFLAGS} FLTK_LIBRARIES)
	endif()

	message(STATUS ${FLTK_LDFLAGS})


	set(GUI_LIBRARIES zynaddsubfx_gui ${FLTK_LIBRARIES} ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES})
    if(X11_FOUND)
        set(GUI_LIBRARIES ${GUI_LIBRARIES} ${X11_LIBRARIES} -lXpm)
    endif()

	add_definitions(-DFLTK_GUI)
	message(STATUS "Will build FLTK gui")

	include_directories(
			${FLTK_INCLUDE_DIR}
			"${CMAKE_CURRENT_SOURCE_DIR}/UI"
			"${CMAKE_CURRENT_BINARY_DIR}/UI"
			)

	add_subdirectory(UI)
endif()

if(NtkGui)

        find_program( FLTK_FLUID_EXECUTABLE ntk-fluid)
        
	message(STATUS ${NTK_LDFLAGS} ${NTK_IMAGES_LDFLAGS})

	set(GUI_LIBRARIES zynaddsubfx_gui ${NTK_LIBRARIES} ${NTK_IMAGES_LIBRARIES} ${OPENGL_LIBRARIES})

    if(X11_FOUND)
        set(GUI_LIBRARIES ${GUI_LIBRARIES} ${X11_LIBRARIES} -lXpm)
    endif()

	add_definitions(-DNTK_GUI)

	message(STATUS "Will build NTK gui")

	include_directories(
			${NTK_INCLUDE_DIRS}
			"${CMAKE_CURRENT_SOURCE_DIR}/UI"
			"${CMAKE_CURRENT_BINARY_DIR}/UI"
			)

	add_subdirectory(UI)
endif()

if(NOT FltkGui AND NOT NtkGui)
    if(LibloEnable)
        set(NSM_WORKAROUND UI/NSM.C UI/NSM/Client.C)
    endif()
    add_library(zynaddsubfx_gui_bridge STATIC UI/ConnectionDummy.cpp ${NSM_WORKAROUND})
    add_definitions(-DNO_UI=1)
endif()

########### General section ##############
# Following this should be only general compilation code, and no mention
# of module-specific variables

link_directories(${AUDIO_LIBRARY_DIRS} ${ZLIB_LIBRARY_DIRS} ${FFTW_LIBRARY_DIRS} ${MXML_LIBRARY_DIRS} ${FLTK_LIBRARY_DIRS} ${NTK_LIBRARY_DIRS})

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	)



set(NONGUI_LIBRARIES
	zynaddsubfx_misc
	zynaddsubfx_synth
	zynaddsubfx_effect
	zynaddsubfx_params
	zynaddsubfx_dsp
	zynaddsubfx_nio
	)

add_subdirectory(Misc)
add_subdirectory(Synth)
add_subdirectory(Effects)
add_subdirectory(Params)
add_subdirectory(DSP)
add_subdirectory(Nio)

add_library(zynaddsubfx_core STATIC
    ../tlsf/tlsf.c
	${zynaddsubfx_dsp_SRCS}
	${zynaddsubfx_effect_SRCS}
	${zynaddsubfx_misc_SRCS}
	${zynaddsubfx_params_SRCS}
	${zynaddsubfx_synth_SRCS}
	)

target_link_libraries(zynaddsubfx_core
	${ZLIB_LIBRARIES}
	${FFTW_LIBRARIES}
	${MXML_LIBRARIES}
	${OS_LIBRARIES}
	pthread
    rtosc rtosc-cpp)

if(CompileTests)
	add_subdirectory(Tests)
endif(CompileTests)


add_executable(zynaddsubfx main.cpp)

#Warning: the required ordering of these to get proper linking depends upon the
#         phase of the moon
target_link_libraries(zynaddsubfx
    zynaddsubfx_core
	zynaddsubfx_nio
    zynaddsubfx_gui_bridge
	${GUI_LIBRARIES}
	${NIO_LIBRARIES}
	${AUDIO_LIBRARIES}
	)

if (DssiEnable)
	add_library(zynaddsubfx_dssi SHARED
        UI/ConnectionDummy.cpp
		Output/DSSIaudiooutput.cpp
		)

	target_link_libraries(zynaddsubfx_dssi
        zynaddsubfx_core
		${OS_LIBRARIES}
        ${LIBLO_LIBRARIES}
		)
	if (${CMAKE_SIZEOF_VOID_P} EQUAL "8")
		install(TARGETS zynaddsubfx_dssi LIBRARY DESTINATION lib64/dssi/)
	else ()
		install(TARGETS zynaddsubfx_dssi LIBRARY DESTINATION lib/dssi/)
	endif ()
endif()

install(TARGETS zynaddsubfx
	RUNTIME DESTINATION bin
	)
if(NtkGui)

=== src/Misc/CMakeLists.txt ===
include_directories(${MXML_INCLUDE_DIR})

set(zynaddsubfx_misc_SRCS
	Misc/Bank.cpp
	Misc/Config.cpp
	Misc/Master.cpp
	Misc/Microtonal.cpp
	Misc/Part.cpp
	Misc/Util.cpp
	Misc/XMLwrapper.cpp
	Misc/Recorder.cpp
	Misc/WavFile.cpp
	Misc/WaveShapeSmps.cpp
    Misc/MiddleWare.cpp
    Misc/PresetExtractor.cpp
    Misc/Allocator.cpp
)



if(LashEnable)
	set(zynaddsubfx_misc_SRCS
		${zynaddsubfx_misc_SRCS}
		Misc/LASHClient.cpp
		PARENT_SCOPE)
else()
	set(zynaddsubfx_misc_SRCS
		${zynaddsubfx_misc_SRCS}
		PARENT_SCOPE)
endif()

=== src/Tests/CMakeLists.txt ===
#for tests looking for files stored in the source dir
add_definitions(-DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

CXXTEST_ADD_TEST(ControllerTest ControllerTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/ControllerTest.h)
CXXTEST_ADD_TEST(EchoTest EchoTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/EchoTest.h)
#CXXTEST_ADD_TEST(SampleTest SampleTest.h)
CXXTEST_ADD_TEST(MicrotonalTest MicrotonalTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MicrotonalTest.h)
CXXTEST_ADD_TEST(XMLwrapperTest XMLwrapper.cpp ${CMAKE_CURRENT_SOURCE_DIR}/XMLwrapperTest.h)
CXXTEST_ADD_TEST(ADnoteTest AdNoteTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/AdNoteTest.h)
CXXTEST_ADD_TEST(SUBnoteTest SubNoteTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/SubNoteTest.h)
CXXTEST_ADD_TEST(OscilGenTest OscilGenTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/OscilGenTest.h)
CXXTEST_ADD_TEST(RandTest RandTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/RandTest.h)
CXXTEST_ADD_TEST(PADnoteTest PadNoteTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/PadNoteTest.h)
CXXTEST_ADD_TEST(PluginTest PluginTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/PluginTest.h)
CXXTEST_ADD_TEST(MiddlewareTest MiddlewareTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MiddlewareTest.h)
CXXTEST_ADD_TEST(UnisonTest UnisonTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/UnisonTest.h)
#CXXTEST_ADD_TEST(RtAllocTest RtAllocTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/RtAllocTest.h)
CXXTEST_ADD_TEST(AllocatorTest AllocatorTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/AllocatorTest.h)

#Extra libraries added to make test and full compilation use the same library
#links for quirky compilers
set(test_lib zynaddsubfx_core ${GUI_LIBRARIES} ${ZLIB_LIBRARY} ${FFTW_LIBRARIES} ${MXML_LIBRARIES} pthread)

message(STATUS "Linking tests with: ${test_lib}")
target_link_libraries(ADnoteTest     ${test_lib})
target_link_libraries(SUBnoteTest    ${test_lib})
target_link_libraries(ControllerTest ${test_lib})
target_link_libraries(EchoTest       ${test_lib})
target_link_libraries(MicrotonalTest ${test_lib})
target_link_libraries(OscilGenTest   ${test_lib})
target_link_libraries(XMLwrapperTest ${test_lib})
target_link_libraries(RandTest       ${test_lib})
target_link_libraries(PADnoteTest    ${test_lib})
target_link_libraries(PluginTest     zynaddsubfx_core zynaddsubfx_nio
    zynaddsubfx_gui_bridge
    ${GUI_LIBRARIES} ${NIO_LIBRARIES} ${AUDIO_LIBRARIES})
target_link_libraries(MiddlewareTest zynaddsubfx_core zynaddsubfx_nio
    zynaddsubfx_gui_bridge
    ${GUI_LIBRARIES} ${NIO_LIBRARIES} ${AUDIO_LIBRARIES})
target_link_libraries(UnisonTest    ${test_lib})
#target_link_libraries(RtAllocTest    ${test_lib})
target_link_libraries(AllocatorTest    ${test_lib})

#Testbed app
add_executable(ins-test InstrumentStats.cpp)
target_link_libraries(ins-test ${test_lib} rt)

#message(STATUS "Plugin Test ${GUI_LIBRARIES} ${NIO_LIBRARIES} ${AUDIO_LIBRARIES}")

=== src/UI/CMakeLists.txt ===
set(UI_fl_files
    ADnoteUI.fl
    BankUI.fl
    ConfigUI.fl
    EffUI.fl
    EnvelopeUI.fl
    FilterUI.fl
    LFOUI.fl
    MasterUI.fl
    MicrotonalUI.fl
    OscilGenUI.fl
    PADnoteUI.fl
    PartUI.fl
    PresetsUI.fl
    ResonanceUI.fl
    SUBnoteUI.fl
    VirKeyboard.fl
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set_source_files_properties(UI/MasterUI.h PROPERTIES GENERATED 1)
fltk_wrap_ui(zynaddsubfx_gui ${UI_fl_files})

if(LibloEnable)
    set(zynaddsubfx_gui_FLTK_UI_SRCS ${zynaddsubfx_gui_FLTK_UI_SRCS} NSM.C NSM/Client.C)
endif()
if(NtkGui)
    add_definitions(-DPIXMAP_PATH="${CMAKE_INSTALL_PREFIX}/share/zynaddsubfx/pixmaps/")
    add_definitions(-DSOURCE_DIR="${CMAKE_SOURCE_DIR}")
endif()

if(FltkGui)
    add_executable(zynaddsubfx-ext-gui guimain.cpp)
    target_link_libraries(zynaddsubfx-ext-gui zynaddsubfx_gui ${FLTK_LIBRARIES}
        ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES} ${LIBLO_LIBRARIES} rtosc rtosc-cpp)
    if(X11_FOUND)
        target_link_libraries(zynaddsubfx-ext-gui ${X11_LIBRARIES} -lXpm)
    endif()
    install(TARGETS zynaddsubfx-ext-gui RUNTIME DESTINATION bin)
elseif(NtkGui)
    add_executable(zynaddsubfx-ext-gui guimain.cpp)
    target_link_libraries(zynaddsubfx-ext-gui zynaddsubfx_gui ${NTK_LDFLAGS}
        ${OPENGL_LIBRARIES} ${LIBLO_LIBRARIES} rtosc rtosc-cpp)
    if(X11_FOUND)
        target_link_libraries(zynaddsubfx-ext-gui ${X11_LIBRARIES} -lXpm)
    endif()
    install(TARGETS zynaddsubfx-ext-gui RUNTIME DESTINATION bin)
endif()

add_library(zynaddsubfx_gui STATIC
	${UI_objs}
	${zynaddsubfx_gui_FLTK_UI_SRCS}
        NioUI.cpp
        WidgetPDial.cpp
        PartNameButton.cpp
        Fl_Osc_Pane.cpp
        Fl_Osc_Widget.cpp
        Fl_Osc_Dial.cpp
        Fl_Osc_DialF.cpp
        Fl_Osc_Slider.cpp
        Fl_Osc_VSlider.cpp
        Fl_Osc_Button.cpp
        Fl_Osc_Check.cpp
        Fl_Osc_Choice.cpp
        Fl_Osc_Roller.cpp
        Fl_Osc_Output.cpp
        Fl_Osc_Counter.cpp
        Fl_Osc_Input.cpp
        Fl_Osc_Numeric_Input.cpp
        Fl_Osc_Value.cpp
        Fl_Osc_ListView.cpp
        Fl_Resonance_Graph.cpp
        Fl_EQGraph.cpp
        FormantFilterGraph.cpp
        EnvelopeFreeEdit.cpp
        BankView.cpp
	)
add_library(zynaddsubfx_gui_bridge STATIC
    Connection.cpp)
add_dependencies(zynaddsubfx_gui_bridge zynaddsubfx_gui)


if(NtkGui)
  target_link_libraries(zynaddsubfx_gui ${NTK_LIBRARIES} ${NTK_IMAGES_LIBRARIES})
endif(NtkGui)

if(FltkGui)
  target_link_libraries(zynaddsubfx_gui ${FLTK_LIBRARIES})
endif(FltkGui)

=== debian/changelog ===
zynaddsubfx (2.5.1-3) unstable; urgency=medium

  * Added patch to fix build on armel arch.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 29 Sep 2015 22:41:40 +0200

zynaddsubfx (2.5.1-2) unstable; urgency=medium

  * Add patch to fix build on some archs.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 08 Sep 2015 23:03:32 +0200

zynaddsubfx (2.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file to be more flexible.
  * Update build deps.
  * Update docs file.
  * Refresh patches

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 05 Jul 2015 00:41:20 +0200

zynaddsubfx (2.4.3-6) unstable; urgency=medium

  * Fix install on 32bit systems.(Closes: #789345)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 20 Jun 2015 08:39:41 +0200

=== debian/control ===
Source: zynaddsubfx
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 cmake (>= 2.4),
 debhelper (>= 9.20120417~),
 fluid (>= 1.3.0),
 libasound2-dev (>= 0.9.4) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libfftw3-dev,
 libfltk1.3-dev,
 libjack-dev,
 liblo-dev (>= 0.26~repack),
 dssi-dev (>= 0.9.0),
 libmxml-dev (>= 2.0),
 zlib1g-dev,
 libxpm-dev
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/zynaddsubfx.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/zynaddsubfx.git
Homepage: http://zynaddsubfx.sourceforge.net

Package: zynaddsubfx
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime software synthesizer for Linux
 A real-time software synthesizer for Linux and Windows with many
 features, including polyphony, multi-timbral and microtonal
 capabilities. It includes randomness of some parameters, which
 makes warm sounds, like analogue synthesizers.
 It has system/insertion effects too, and much more.

Package: zynaddsubfx-dssi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: dssi plugin of zynaddsubfx
 A real-time software synthesizer for Linux and Windows with many
 features, including polyphony, multi-timbral and microtonal
 capabilities. It includes randomness of some parameters, which
 makes warm sounds, like analogue synthesizers.
 It has system/insertion effects too, and much more.
 .
 This package provide dssi plugin of zynaddsubfx.

Package: zynaddsubfx-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
 zynaddsubfx (= ${binary:Version}),
 ${misc:Depends}
Description: Debugging symbols for zynaddsubfx
 A real-time software synthesizer for Linux and Windows with many
 features, including polyphony, multi-timbral and microtonal
 capabilities. It includes randomness of some parameters, which
 makes warm sounds, like analogue synthesizers.
 It has system/insertion effects too, and much more.
 .
 This package contains the debugging symbols.

## zynaddsubfx 2.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 2.8)
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
 project(zynaddsubfx)
-set(VERSION "2.5.1")
+set(VERSION "2.5.2")
 
 
 #Include RTOSC
@@ -28,7 +28,7 @@
 #Currently the only directory that uses cmake
 add_subdirectory(src)
 
-install(FILES AUTHORS.txt COPYING FAQ.txt HISTORY.txt README.adoc
+install(FILES AUTHORS.txt COPYING HISTORY.txt README.adoc
 	DESTINATION share/doc/zynaddsubfx
 	)
 install(FILES zynaddsubfx-jack.desktop zynaddsubfx-alsa.desktop

=== doc/Makefile ===

.PHONY: subdirs gen

all: gen-files man xhtml chunked pdf

gen-files:
	cd gen; make


xhtml: zynaddsubfx.txt envelope.txt intro.txt lfo.txt
	asciidoc -a numbered -a toc -b html5 \
		-a latexmath \
		zynaddsubfx.txt

chunked:
	asciidoc --doctype=article   -b docbook \
	          zynaddsubfx.txt
	rm -rf ./zynaddsubfx.chunked
	mkdir ./zynaddsubfx.chunked
	rm -f "./zynaddsubfx.chunked/*.html"
	ln -s ../images/ zynaddsubfx.chunked/images
	xsltproc --stringparam html.stylesheet "./docbook-xsl.css" \
	         --stringparam callout.graphics 0 \
		 --stringparam navig.graphics 0 \
		 --stringparam admon.textlabel 1 \
		 --stringparam admon.graphics 0 \
		 --nonet \
	         --stringparam base.dir "zynaddsubfx.chunked/" \
	         "/etc/asciidoc/docbook-xsl/chunked.xsl" \
		 "./zynaddsubfx.xml" \

pdf:
	a2x -f pdf zynaddsubfx.txt

man: zynaddsubfx.1.txt
	a2x -f manpage zynaddsubfx.1.txt

clean:
	rm -f *~ *html *pdf *xml *tex *log zynaddsubfx.chunked/images
	rm -r -f zynaddsubfx.chunked/

=== rtosc/CMakeLists.txt ===
--- 
+++ 
@@ -13,10 +13,21 @@
     include(GNUInstallDirs)
 endif()
 
+
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
-if(NOT WIN32)
-    set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -O2 -fPIC -std=c99   -Wall -Wextra")
-    set(CPP_FLAGS       "-O2 -fPIC -std=c++11 -Wall -Wextra -Wno-unused-parameter")
+set(CXX11_FLAG "-std=c++11")
+set(FPIC_FLAG "-fPIC")
+set(OPT_FLAG "-O2")
+if(CMAKE_BUILD_TYPE STREQUAL Debug)
+    set(OPT_FLAG "")
+endif()
+if(WIN32)
+    #code is position-independent by default on Windows
+    set(FPIC_FLAG "")
+endif()
+if(NOT WIN32 OR CMAKE_COMPILER_IS_GNUCC)
+    set(CMAKE_C_FLAGS   "${OPT_FLAG} ${CMAKE_C_FLAGS} -fPIC -std=c99   -Wall -Wextra")
+    set(CPP_FLAGS       "${OPT_FLAG} ${FPIC_FLAG} -Wall -Wextra -Wno-unused-parameter")
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCC)
@@ -27,11 +38,11 @@
         message(STATUS "Found GCC Version >= 4.7")
     else()
         message(WARNING "GCC Version '${GCC_VERSION}' Is Quite Old, Please Consider Upgrading")
-        set(CPP_FLAGS "-O2 -fPIC -std=c++0x -Wall -Wextra -Wno-unused-parameter")
+        set(CXX11_FLAG "-std=c++0x")
     endif()
 endif()
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPP_FLAGS}")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CPP_FLAGS} ${CXX11_FLAG}")
 
 add_library(rtosc STATIC src/rtosc.c src/dispatch.c)
 add_library(rtosc-cpp STATIC src/cpp/ports.cpp src/cpp/miditable.cpp
@@ -120,6 +131,7 @@
 maketest(fat-message)
 maketest(empty-strings)
 maketest(message-alignment)
+maketest(test-arg-iter)
 if(LIBLO_FOUND)
     include_directories(${LIBLO_INCLUDE_DIRS})
     maketest(liblo)
@@ -138,7 +150,11 @@
 maketestcpp(undo-test)
 maketestcpp(serializer)
 maketestcpp(sugar)
-maketestcpp(typed-template-test)
+if(CXX11_FLAG STREQUAL "-std=c++11")
+    maketestcpp(typed-template-test)
+endif()
+
+maketestcpp(path-collapse)
 
 # Documentation
 find_package(Doxygen)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,12 @@
 
 #Dependency check
 include(CheckFunctionExists)
+include(CheckIncludeFile)
+include(CheckCXXSourceCompiles)
 find_package(PkgConfig REQUIRED)
 find_package(zlib REQUIRED)
 find_package(X11)
+check_include_file(X11/xpm.h HAS_XPM)
 pkg_check_modules(FFTW REQUIRED fftw3)
 pkg_check_modules(MXML REQUIRED mxml)
 find_package(Threads   REQUIRED)
@@ -32,6 +35,15 @@
 mark_as_advanced(LIBLO_LIBRARIES)
 
 CHECK_FUNCTION_EXISTS(sched_setscheduler HAVE_SCHEDULER)
+set(CMAKE_REQUIRED_FLAGS "-std=c++11")
+CHECK_CXX_SOURCE_COMPILES(
+    "#include <future>
+    #if ATOMIC_INT_LOCK_FREE<2
+    #error unreliable atomics
+    #endif
+    int main(){return 0;}" HAVE_ASYNC)
+set(CMAKE_REQUIRED_FLAGS "")
+
 
 execute_process(COMMAND echo fistpl 0
                 COMMAND as -
@@ -73,6 +85,12 @@
 if(NOT "Darwin" STREQUAL ${CMAKE_SYSTEM_NAME})
     # Add scheduler function existance info (OSX compatiability)
     add_definitions(-DHAVE_SCHEDULER=${HAVE_SCHEDULER})
+endif()
+
+if(HAVE_ASYNC)
+    add_definitions(-DHAVE_ASYNC=1)
+else()
+    add_definitions(-DHAVE_ASYNC=0)
 endif()
 
 
@@ -267,7 +285,7 @@
 
 
 	set(GUI_LIBRARIES zynaddsubfx_gui ${FLTK_LIBRARIES} ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES})
-    if(X11_FOUND)
+    if(X11_FOUND AND HAS_XPM)
         set(GUI_LIBRARIES ${GUI_LIBRARIES} ${X11_LIBRARIES} -lXpm)
     endif()
 
@@ -291,7 +309,7 @@
 
 	set(GUI_LIBRARIES zynaddsubfx_gui ${NTK_LIBRARIES} ${NTK_IMAGES_LIBRARIES} ${OPENGL_LIBRARIES})
 
-    if(X11_FOUND)
+    if(X11_FOUND AND HAS_XPM)
         set(GUI_LIBRARIES ${GUI_LIBRARIES} ${X11_LIBRARIES} -lXpm)
     endif()
 
@@ -346,7 +364,10 @@
 add_subdirectory(Nio)
 
 add_library(zynaddsubfx_core STATIC
+    globals.cpp
     ../tlsf/tlsf.c
+    Containers/NotePool.cpp
+    Containers/MultiPseudoStack.cpp
 	${zynaddsubfx_dsp_SRCS}
 	${zynaddsubfx_effect_SRCS}
 	${zynaddsubfx_misc_SRCS}
@@ -377,28 +398,3 @@
     zynaddsubfx_gui_bridge
 	${GUI_LIBRARIES}
 	${NIO_LIBRARIES}
-	${AUDIO_LIBRARIES}
-	)
-
-if (DssiEnable)
-	add_library(zynaddsubfx_dssi SHARED
-        UI/ConnectionDummy.cpp
-		Output/DSSIaudiooutput.cpp
-		)
-
-	target_link_libraries(zynaddsubfx_dssi
-        zynaddsubfx_core
-		${OS_LIBRARIES}
-        ${LIBLO_LIBRARIES}
-		)
-	if (${CMAKE_SIZEOF_VOID_P} EQUAL "8")
-		install(TARGETS zynaddsubfx_dssi LIBRARY DESTINATION lib64/dssi/)
-	else ()
-		install(TARGETS zynaddsubfx_dssi LIBRARY DESTINATION lib/dssi/)
-	endif ()
-endif()
-
-install(TARGETS zynaddsubfx
-	RUNTIME DESTINATION bin
-	)
-if(NtkGui)

=== src/Nio/CMakeLists.txt ===
#Defaults:
#         - Wave Output (enabled with the record function)
#         - Null Output
#         - Null Output Running by default
#         - Managed with OutMgr
set(zynaddsubfx_nio_SRCS
    WavEngine.cpp
    NulEngine.cpp
    AudioOut.cpp
    MidiIn.cpp
    OutMgr.cpp
    InMgr.cpp
    Engine.cpp
    EngineMgr.cpp
    Nio.cpp
    )

set(zynaddsubfx_nio_lib)

add_definitions(-DOUT_DEFAULT="${DefaultOutput}")
add_definitions(-DIN_DEFAULT="${DefaultInput}")

if(JackEnable)
    include_directories(${JACK_INCLUDE_DIR})
    list(APPEND zynaddsubfx_nio_SRCS JackEngine.cpp JackMultiEngine.cpp)
    list(APPEND zynaddsubfx_nio_lib ${JACK_LIBRARIES})

    CHECK_INCLUDE_FILES("jack/metadata.h" JACK_HAS_METADATA_API)
    if(JACK_HAS_METADATA_API)
        add_definitions(-DJACK_HAS_METADATA_API)
    endif(JACK_HAS_METADATA_API)
endif(JackEnable)

if(PaEnable)
    include_directories(${PORTAUDIO_INCLUDE_DIRS})
    list(APPEND zynaddsubfx_nio_SRCS PaEngine.cpp)
    list(APPEND zynaddsubfx_nio_lib ${PORTAUDIO_LIBRARIES})
endif(PaEnable)

if(AlsaEnable)
    list(APPEND zynaddsubfx_nio_SRCS AlsaEngine.cpp)
    list(APPEND zynaddsubfx_nio_lib ${ASOUND_LIBRARY})
endif(AlsaEnable)

if(OssEnable)
    list(APPEND zynaddsubfx_nio_SRCS OssEngine.cpp OssMultiEngine.cpp)
endif(OssEnable)


add_library(zynaddsubfx_nio STATIC
    ${zynaddsubfx_nio_SRCS} 
    )

=== src/Tests/CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,14 @@
 CXXTEST_ADD_TEST(PADnoteTest PadNoteTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/PadNoteTest.h)
 CXXTEST_ADD_TEST(PluginTest PluginTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/PluginTest.h)
 CXXTEST_ADD_TEST(MiddlewareTest MiddlewareTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MiddlewareTest.h)
+CXXTEST_ADD_TEST(MessageTest MessageTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MessageTest.h)
 CXXTEST_ADD_TEST(UnisonTest UnisonTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/UnisonTest.h)
+CXXTEST_ADD_TEST(MqTest MqTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/MqTest.h)
 #CXXTEST_ADD_TEST(RtAllocTest RtAllocTest.cpp ${CMAKE_CURRENT_SOURCE_DIR}/RtAllocTest.h)
 CXXTEST_ADD_TEST(AllocatorTest AllocatorTest.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/AllocatorTest.h)
+CXXTEST_ADD_TEST(KitTest KitTest.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/KitTest.h)
 
 #Extra libraries added to make test and full compilation use the same library
 #links for quirky compilers
@@ -33,15 +37,20 @@
 target_link_libraries(XMLwrapperTest ${test_lib})
 target_link_libraries(RandTest       ${test_lib})
 target_link_libraries(PADnoteTest    ${test_lib})
+target_link_libraries(MqTest         ${test_lib})
 target_link_libraries(PluginTest     zynaddsubfx_core zynaddsubfx_nio
     zynaddsubfx_gui_bridge
     ${GUI_LIBRARIES} ${NIO_LIBRARIES} ${AUDIO_LIBRARIES})
 target_link_libraries(MiddlewareTest zynaddsubfx_core zynaddsubfx_nio
     zynaddsubfx_gui_bridge
     ${GUI_LIBRARIES} ${NIO_LIBRARIES} ${AUDIO_LIBRARIES})
+target_link_libraries(MessageTest zynaddsubfx_core zynaddsubfx_nio
+    zynaddsubfx_gui_bridge
+    ${GUI_LIBRARIES} ${NIO_LIBRARIES} ${AUDIO_LIBRARIES})
 target_link_libraries(UnisonTest    ${test_lib})
 #target_link_libraries(RtAllocTest    ${test_lib})
 target_link_libraries(AllocatorTest    ${test_lib})
+target_link_libraries(KitTest    ${test_lib})
 
 #Testbed app
 add_executable(ins-test InstrumentStats.cpp)

=== src/UI/CMakeLists.txt ===
--- 
+++ 
@@ -34,16 +34,22 @@
     add_executable(zynaddsubfx-ext-gui guimain.cpp)
     target_link_libraries(zynaddsubfx-ext-gui zynaddsubfx_gui ${FLTK_LIBRARIES}
         ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES} ${LIBLO_LIBRARIES} rtosc rtosc-cpp)
-    if(X11_FOUND)
+    if(X11_FOUND AND HAS_XPM)
+        add_definitions(-DHAS_X11=1)
         target_link_libraries(zynaddsubfx-ext-gui ${X11_LIBRARIES} -lXpm)
+    else()
+        add_definitions(-DHAS_X11=0)
     endif()
     install(TARGETS zynaddsubfx-ext-gui RUNTIME DESTINATION bin)
 elseif(NtkGui)
     add_executable(zynaddsubfx-ext-gui guimain.cpp)
     target_link_libraries(zynaddsubfx-ext-gui zynaddsubfx_gui ${NTK_LDFLAGS}
         ${OPENGL_LIBRARIES} ${LIBLO_LIBRARIES} rtosc rtosc-cpp)
-    if(X11_FOUND)
+    if(X11_FOUND AND HAS_XPM)
+        add_definitions(-DHAS_X11=1)
         target_link_libraries(zynaddsubfx-ext-gui ${X11_LIBRARIES} -lXpm)
+    else()
+        add_definitions(-DHAS_X11=0)
     endif()
     install(TARGETS zynaddsubfx-ext-gui RUNTIME DESTINATION bin)
 endif()
@@ -52,6 +58,7 @@
 	${UI_objs}
 	${zynaddsubfx_gui_FLTK_UI_SRCS}
         NioUI.cpp
+	TipWin.cpp
         WidgetPDial.cpp
         PartNameButton.cpp
         Fl_Osc_Pane.cpp
@@ -59,6 +66,7 @@
         Fl_Osc_Dial.cpp
         Fl_Osc_DialF.cpp
         Fl_Osc_Slider.cpp
+        Fl_Osc_TSlider.cpp
         Fl_Osc_VSlider.cpp
         Fl_Osc_Button.cpp
         Fl_Osc_Check.cpp

=== debian/changelog ===
zynaddsubfx (2.5.2-2ubuntu1) xenial; urgency=medium

  * debian/patches/0007-isnan.patch: Grab patch from upstream Git to fix FTBFS
    with libc 2.23 due to unqualified isnan.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 09 Apr 2016 08:03:03 +0000

zynaddsubfx (2.5.2-2) unstable; urgency=medium

  * Fix copyright file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 02 Dec 2015 00:26:43 +0100

zynaddsubfx (2.5.2-1) unstable; urgency=medium

  [ Jaromír Mikeš ]
  * Imported Upstream version 2.5.2
  * Patches refreshed.
  * FAQ.txt removed upstream.
  * Add patch to fix build.
  * Install upstream desktop files and icon.
  * Removed menu file (in response to the tech-ctte decision on #741573).
  * Add Keywords to desktop files.
  * Add another spelling patch.
  * Update copyright file.
  * Remove debian/desktop file.
  * Introduce zynaddsubfx-data package.

  [ Sebastian Ramacher ]
  * debian/control: Bump versions in Breaks + Replaces.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 23 Nov 2015 21:39:33 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: zynaddsubfx
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
@@ -25,6 +26,7 @@
 Package: zynaddsubfx
 Architecture: any
 Depends:
+ zynaddsubfx-data,
  ${misc:Depends},
  ${shlibs:Depends}
 Description: Realtime software synthesizer for Linux
@@ -33,6 +35,22 @@
  capabilities. It includes randomness of some parameters, which
  makes warm sounds, like analogue synthesizers.
  It has system/insertion effects too, and much more.
+
+Package: zynaddsubfx-data
+Architecture: all
+Depends: ${misc:Depends}
+Recommends: zynaddsubfx
+Breaks: zynaddsubfx (<< 2.5.2-1~)
+Replaces: zynaddsubfx (<< 2.5.2-1~)
+Description: Realtime software synthesizer for Linux (data)
+ A real-time software synthesizer for Linux and Windows with many
+ features, including polyphony, multi-timbral and microtonal
+ capabilities. It includes randomness of some parameters, which
+ makes warm sounds, like analogue synthesizers.
+ It has system/insertion effects too, and much more.
+ .
+ This package contains the architecture-independent data files.
+
 
 Package: zynaddsubfx-dssi
 Architecture: any

=== debian/watch ===
version=3

http://sf.net/zynaddsubfx/zynaddsubfx-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
